{
  TLRItemR
    TLRItemh
    gpۂɂR|[lg
    pۂ̐̑ RoundLeftTop, RoundRightTop LineTop 
    RoundLeftBottom, RoundRightBottom LineBottom Ɉˑ
  vpeB
    RoundSize: Integer  p̊ۂ݂̑傫
    RoundLeftTop: Boolean  p
    RoundLeftBottom: Boolean  p
    RoundRightTop: Boolean  Ep
    RoundRightBottom: Boolean  Ep
    DiagonalRisedLeft: TLineStyle  オ̑Ίp
    DiagonalRisedRight: TLineStyle  Eオ̑Ίp
}

{
  2000.09.07 LRSuppl  DBΉR|ʃjbg(LRDBSpl) ɂ
             ... DB ֘AgpȂꍇ .exe ̗eʂɔz邽
  2001/02/07 TLRItemR ɑΊp悤ɋ@\ǉ
             ȉ̃vpeBǉ
             DiagonalRisedLeft: TLineStyle  オ̑Ίp
             DiagonalRisedRight: TLineStyle  Eオ̑Ίp
}

{$INCLUDE DelphiVer.inc}  // Delphi o[Wf̒`

unit LRSuppl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Mask, LightRep;

type
  // g̊pۑΉR|[lg
  TLRItemR = class(TLRItem)
  private
    FRoundSize: Integer;
    FRoundRect: array[0..3] of Boolean;
    FDiagonalRisedLeft: TLineStyle;
    FDiagonalRisedRight: TLineStyle;
    procedure SetRoundSize(Value: Integer);
    procedure SetLineStyle(Canvas: TCanvas; Style: TLineStyle; PrintScale: double);
    procedure SetRoundRect(const Index: Integer; const Value: Boolean);
    procedure SetDiagonalRisedLeft(const Value: TLineStyle);
    procedure SetDiagonalRisedRight(const Value: TLineStyle);
  protected
    function InsidePoint(ABool: Boolean; X, Y, XOffset, YOffset: Integer): TPoint;
    function DisplayText: string;
    procedure Print(ACanvas: TCanvas; ARect: TRect;
      APrintScale: Double; APrintStatus: TPrintStatus); override;
    procedure PrintFrame(ACanvas: TCanvas; ARect: TRect;
      APrintScale: Double); virtual;
    procedure PrintText(ACanvas: TCanvas; ARect: TRect;
      APrintScale: Double); virtual;
    procedure CornerOfRound(Canvas: TCanvas; Style: TLineStyle; PrintScale: Double;
      X1, Y1, X2, Y2, X3, Y3, X4, Y4, XOffset, YOffset: Integer);
  public
  published
    property DiagonalRisedLeft: TLineStyle read FDiagonalRisedLeft write SetDiagonalRisedLeft;
    property DiagonalRisedRight: TLineStyle read FDiagonalRisedRight write SetDiagonalRisedRight;
    property RoundSize: Integer read FRoundSize write SetRoundSize;
    property RoundLeftTop: Boolean index 0 read FRoundRect[0] write SetRoundRect;
    property RoundLeftBottom: Boolean index 1 read FRoundRect[1] write SetRoundRect;
    property RoundRightTop: Boolean index 2 read FRoundRect[2] write SetRoundRect;
    property RoundRightBottom: Boolean index 3 read FRoundRect[3] write SetRoundRect;
  end;

implementation

{$IFDEF Delphi6Over}
uses  MaskUtils;
{$ENDIF}

{ TLRItemR }

procedure TLRItemR.SetRoundSize(Value: Integer);
begin
  if  (0 > Value) or (20 < Value)  then
    raise Exception.Create('RoundSize  0-20 ͈̔͂̂݋Ă܂D');
  if Value <> FRoundSize then
    begin
      FRoundSize := Value;
      Invalidate;
    end;
end;

procedure TLRItemR.SetRoundRect(const Index: Integer; const Value: Boolean);
begin
  if  FRoundRect[Index] <> Value  then
    begin
      FRoundRect[Index] := Value;
      Invalidate;
    end;
end;

procedure TLRItemR.Print(ACanvas: TCanvas; ARect: TRect;
  APrintScale: Double; APrintStatus: TPrintStatus);
begin
  if  APrintStatus in [psNormal, psLineOnly]  then
    begin
      PrintFrame(ACanvas, ARect, APrintScale);  // g
      if  APrintStatus = psNormal  then
        PrintText(ACanvas, ARect, APrintScale); // eLXg
    end;
  if  csDesigning in ComponentState  then       // ݌vg
    DrowDesignFrame(ACanvas, Color, ARect,
      LineLeft, LineTop, LineRight, LineBottom);
end;

procedure TLRItemR.PrintFrame(ACanvas: TCanvas; ARect: TRect;
  APrintScale: Double);
var
  PrintRect: TRect;
  InsideLeftTop, InsideRightTop, InsideLeftBottom, InsideRightBottom: TPoint;
  ArcInside: TPoint;
  ARoundSize, Offset, OffsetIntercept: Integer;
begin
  // ʂ̃XP[ɕϊ
  with  ARect  do
    PrintRect := PrintScaleRect(Rect(Left, Top, Right-1, Bottom-1), APrintScale);
  ARoundSize := ToPrintScale(FRoundSize, APrintScale);
  // gItZbǧvZ
  if  csDesigning in ComponentState  then  Offset := 0
  else
    begin
      Offset := Trunc(APrintScale);
      PrintRect.Left := PrintRect.Left - Trunc(APrintScale);
      PrintRect.Top := PrintRect.Top - Trunc(APrintScale);
    end;
  // pۗpLine Z
  InsideLeftTop := InsidePoint(RoundLeftTop, PrintRect.Left,
    PrintRect.Top, ARoundSize, ARoundSize);
  InsideRightTop := InsidePoint(RoundRightTop, PrintRect.Right,
    PrintRect.Top, -ARoundSize, ARoundSize);
  InsideLeftBottom := InsidePoint(RoundLeftBottom, PrintRect.Left,
    PrintRect.Bottom, ARoundSize, -ARoundSize);
  InsideRightBottom := InsidePoint(RoundRightBottom, PrintRect.Right,
    PrintRect.Bottom, -ARoundSize, -ARoundSize);
  with  ACanvas  do
  begin
  // gh
    if  TransParent  then  Brush.Style := bsClear
    else
      begin
        Brush.Color := Color;                                //      c-----b
        Pen.Style := psClear;                                //      |     |
        Polygon([InsideLeftTop,                              // 1  2-1     a-9
          Point(PrintRect.Left + Offset, InsideLeftTop.Y),   // 2  |         |
          Point(PrintRect.Left + Offset, InsideLeftBottom.Y),// 3  |         |
          InsideLeftBottom,                                  // 4  3-4     7-8
          Point(InsideLeftBottom.X, PrintRect.Bottom),       // 5    |     |
          Point(InsideRightBottom.X, PrintRect.Bottom),      // 6    5-----6
          InsideRightBottom,                                 // 7  L̂悤ȋ`hĂ
          Point(PrintRect.Right, InsideRightBottom.Y),       // 8  pۂȂꍇ1, 4, 7, a ̒l
          Point(PrintRect.Right, InsideRightTop.Y),          // 9  PrintRect ̒lƓȂ̂
          InsideRightTop,                                    // a      1-c--
          Point(InsideRightTop.X, PrintRect.Top + Offset),   // b      |
          Point(InsideLeftTop.X, PrintRect.Top + Offset)]);  // c      2    ̂悤Ɋpւ܂Ȃ
      end;                                                   //        |
  // g̕`
    Pen.Color := LineColor;
    Pen.Style := psSolid;
    if  LineTop > lsNone  then
    begin
      SetLineStyle(ACanvas, LineTop, APrintScale);
      MoveTo(InsideLeftTop.X, PrintRect.Top);
      LineTo(InsideRightTop.X, PrintRect.Top);
    end;
    if  LineLeft > lsNone  then
    begin
      SetLineStyle(ACanvas, LineLeft, APrintScale);
      MoveTo(PrintRect.Left, InsideLeftTop.Y);
      LineTo(PrintRect.Left, InsideLeftBottom.Y);
    end;
    if  LineRight > lsNone  then
    begin
      SetLineStyle(ACanvas, LineRight, APrintScale);
      if  RoundRightTop  then
        MoveTo(PrintRect.Right, InsideRightTop.Y - Offset)
      else
        MoveTo(PrintRect.Right, InsideRightTop.Y);
      LineTo(PrintRect.Right, InsideRightBottom.Y);
    end;
    if  LineBottom > lsNone  then
    begin
      SetLineStyle(ACanvas, LineBottom, APrintScale);
      if  RoundLeftBottom  then
        MoveTo(InsideLeftBottom.X - Offset, PrintRect.Bottom)
      else
        MoveTo(InsideLeftBottom.X, PrintRect.Bottom);
      LineTo(InsideRightBottom.X, PrintRect.Bottom);
    end;
  end;
  // p
  if  RoundLeftTop  then
    begin
      // pۗpArc p̓̈ʒuvZ
      ArcInside := InsidePoint(RoundLeftTop, PrintRect.Left + 1,
        PrintRect.Top + 1, ARoundSize * 2, ARoundSize * 2);
      // pۂ`
      CornerOfRound(ACanvas, LineTop, APrintScale,
        PrintRect.Left, PrintRect.Top, ArcInside.X, ArcInside.Y,
        InsideLeftTop.X, PrintRect.Top, PrintRect.Left, InsideLeftTop.Y,
        Offset, Offset);
    end;
  // Ep
  if  RoundRightTop  then
    begin
      ArcInside := InsidePoint(RoundRightTop, PrintRect.Right - 1,
        PrintRect.Top + 1, -ARoundSize * 2, ARoundSize * 2);
      CornerOfRound(ACanvas, LineTop, APrintScale,
        ArcInside.X, PrintRect.Top, PrintRect.Right, ArcInside.Y,
        PrintRect.Right, InsideRightTop.Y, InsideRightTop.X, PrintRect.Top,
        0, Offset);
    end;
  // p
  if  RoundLeftBottom  then
    begin
      ArcInside := InsidePoint(RoundLeftBottom, PrintRect.Left + 1,
        PrintRect.Bottom - 1, ARoundSize * 2, -ARoundSize * 2);
      CornerOfRound(ACanvas, LineBottom, APrintScale,
        PrintRect.Left, ArcInside.Y, ArcInside.X, PrintRect.Bottom,
        PrintRect.Left, InsideLeftBottom.Y, InsideLeftBottom.X, PrintRect.Bottom,
        Offset, 0);
    end;
  // Ep
  if  RoundRightBottom  then
    begin
      ArcInside := InsidePoint(RoundRightBottom, PrintRect.Right - 1,
        PrintRect.Bottom - 1, -ARoundSize * 2, -ARoundSize * 2);
      CornerOfRound(ACanvas, LineBottom, APrintScale,
        ArcInside.X, ArcInside.Y, PrintRect.Right, PrintRect.Bottom,
        InsideRightBottom.X, PrintRect.Bottom, PrintRect.Right, InsideRightBottom.Y,
        0, 0);
    end;
  // Ίp
  // pۂ̐ؕЗp̃ItZbg߂
  if  ARoundSize = 0  then
    OffsetIntercept := 0
  else
    OffsetIntercept := Trunc(Sqr(ARoundSize) / Sqrt(Sqr(ARoundSize) * 2)) - 1; // Ɠ
  with  ACanvas  do
  begin
    // オ̑Ίp
    if  DiagonalRisedLeft > lsNone  then
      begin
        SetLineStyle(ACanvas, DiagonalRisedLeft, APrintScale);
        if  RoundLeftTop  then
          MoveTo(InsideLeftTop.X - OffsetIntercept, InsideLeftTop.Y - OffsetIntercept)
        else
          MoveTo(PrintRect.Left, PrintRect.Top);
        if  RoundRightBottom  then
          LineTo(InsideRightBottom.X + OffsetIntercept, InsideRightBottom.Y + OffsetIntercept)
        else
          LineTo(PrintRect.Right, PrintRect.Bottom);
      end;
    // Eオ̑Ίp
    if  DiagonalRisedRight > lsNone  then
      begin
        SetLineStyle(ACanvas, DiagonalRisedRight, APrintScale);
        if  RoundLeftBottom  then
          MoveTo(InsideLeftBottom.X - OffsetIntercept, InsideLeftBottom.Y + OffsetIntercept)
        else
          MoveTo(PrintRect.Left, PrintRect.Bottom);
        if  RoundRightTop  then
          LineTo(InsideRightTop.X + OffsetIntercept, InsideRightTop.Y - OffsetIntercept)
        else
          LineTo(PrintRect.Right, PrintRect.Top);
      end;
  end;
end;

procedure TLRItemR.SetLineStyle(Canvas: TCanvas; Style: TLineStyle;
  PrintScale: double);
begin
  // Style ɉāAʏ̐̑ς
  // vCx[gȂ̂ōĒ`(Ohtaka)
  if (csDesigning in ComponentState) then
    case Style of
      lsHalf: Canvas.Pen.Color := clSilver;
      lsSingle: Canvas.Pen.Color := clGray;
      lsDouble: Canvas.Pen.Color := clBlack;
    end
  else
    case Style of
      lsHalf: Canvas.Pen.Width := Trunc(PrintScale / 2);
      lsSingle: Canvas.Pen.Width := Trunc(PrintScale * 1.2);
      lsDouble: Canvas.Pen.Width := Trunc(PrintScale * 2);
    end;
end;

function TLRItemR.InsidePoint(ABool: Boolean; X, Y,
  XOffset, YOffset: Integer): TPoint;
begin
  // pۗpLine Z邽߂̈ʒuvZ
  if  ABool  then
    begin
      Result.X := X + XOffset;
      Result.Y := Y + YOffset;
    end
  else
    begin
      Result.X := X;
      Result.Y := Y;
    end;
end;

procedure TLRItemR.CornerOfRound(Canvas: TCanvas; Style: TLineStyle;
   PrintScale: Double; X1, Y1, X2, Y2, X3, Y3, X4, Y4, XOffset, YOffset: Integer);
begin
  // epۂ
  // X1, X1, Y1, X2, Y2, X3, Y3, X4, Y4 ɂĂ
  // TCanvas.Pie  TCanvas.Arc Help QƂ̂


  //  1=(X1, Y1) 2=(X2, Y2)
  //  3=(X3, Y3) 4=(X4, Y4)              1  2 ŕ\`(A)ɐڂ~̈ꕔ
  //                                     ƂŊpۂ\
  //      E               `(A)̓ӂ͊pۃTCY(RoundSize)
  //  1..3--- 1--4... 1...... 1.....|    ̔{Ƃ
  //  .^   . .   _. |     . .     |    v̋tŉ~̈ꕔ`
  //  4     . .     3 3     . .     4    3  4 ̈ʒu͐`(A)̒Ԃ̈ʒu
  //  |     . .     | ._   . .   ^.    \Ă
  //  |.....2 ......2 ...4--2 ---3..2    ɐ`̕hāAʂ̕
  //                                     Ă
  with  Canvas  do
  begin
    // pۓh
    if  not Transparent  then
      begin
        Pen.Style := psClear;
        Pen.Color := clWhite;   // psClear ł̓v^[ɂĂ͕`Ă܂ꍇ邽
        Pie(X1 + XOffset, Y1 + YOffset, X2 + XOffset, Y2 + YOffset,
          X3 + XOffset, Y3 + YOffset, X4 + XOffset, Y4 + YOffset);
      end;
    // pۂ
    if  Style <> lsNone  then
      begin
        Pen.Color := LineColor;
        SetLineStyle(Canvas, Style, PrintScale);
        Pen.Style := psSolid;
        Arc(X1, Y1, X2, Y2, X3, Y3, X4, Y4);
      end;
  end;
end;

procedure TLRItemR.PrintText(ACanvas: TCanvas; ARect: TRect;
  APrintScale: Double);
var
  SV_TextHeight: Integer;
  AText: string;
  Flags: Integer;
  CalcRect: TRect;        // WordwrapɈeLXg̍vZ邽߂Rect
  PrintRect: TRect;       // ̈
begin
  ACanvas.Font := Self.Font;
  AText := Self.DisplayText;
  SV_TextHeight := ACanvas.TextHeight('|');
  // tÕZbg
  Flags := DT_NOPREFIX;
  if  WordWrap  then  Flags := Flags or DT_WORDBREAK
  else  Flags := Flags or DT_SINGLELINE;
  case  Alignment  of
    taLeftJustify: Flags := Flags or DT_LEFT;
    taRightJustify: Flags := Flags or DT_RIGHT;
    else  Flags := Flags or DT_CENTER;
  end;

  // ʒǔvZ
  with  ARect  do
    PrintRect := PrintScaleRect(Rect(Left, Top, Right-1, Bottom-1), APrintScale);
  with  CalcRect  do
  begin
    Top := 0;
    Bottom := SV_TextHeight;
    Left := 0;
    Right := PrintRect.Right - PrintRect.Left - ToPrintScale(HMargin, APrintScale);
  end;
  DrawText(ACanvas.Handle, PChar(AText), -1, CalcRect, Flags or DT_CALCRECT);
  SV_TextHeight := CalcRect.Bottom;

  // ʒu
  with  PrintRect  do
  case  Alignment  of
    taLeftJustify: Left := Left + ToPrintScale(HMargin, APrintScale);
    taRightJustify: Right := Right - ToPrintScale(HMargin, APrintScale);
  end;
  // cʒu
  with  PrintRect  do
  case  Layout  of
    tlTop: Top := Top + ToPrintScale(VMargin, APrintScale);
    tlBottom: Top := Bottom - ToPrintScale(VMargin, APrintScale) - SV_TEXTHEIGHT;
    else
      Top := Top + (PrintRect.Bottom - PrintRect.Top - SV_TEXTHEIGHT) div 2;
  end;

  // ̕`
  DrawText(ACanvas.Handle, PChar(AText), -1, PrintRect, Flags);
end;

function TLRItemR.DisplayText: string;
var
  s: string;
  i: Integer;
  flg: boolean;
begin
  // }XNw肳Ă
  if  (DisplayMask <> '') and (Caption <> '')  then
    begin
      s := Caption;
      flg := True;
      for  i := 1 to Length(s)  do
        if  not (s[i] in ['0'..'9', '.', '-', '+'])  then
          begin
            flg := False;
            Break;
          end;
      // ɕϊłꍇFormatFloatg
      if  flg  then
        Result := FormatFloat(DisplayMask, StrToFloat(Caption))
      else
        // ȊȌꍇFormatMuskTextg
        Result := FormatMaskText(DisplayMask, Caption);
    end
  else
    Result := Caption;
end;

procedure TLRItemR.SetDiagonalRisedLeft(const Value: TLineStyle);
begin
  if  FDiagonalRisedLeft <> Value  then
    begin
      FDiagonalRisedLeft := Value;
      Invalidate;
    end;
end;

procedure TLRItemR.SetDiagonalRisedRight(const Value: TLineStyle);
begin
  if  FDiagonalRisedRight <> Value  then
    begin
      FDiagonalRisedRight := Value;
      Invalidate;
    end;
end;

end.
