{*
 *
 *   LightRepEx
 *
 *   TLRImegeR|lg
 *   C[WgpȂvÕt@CTCY邽
 *   LightRep番
 *
 *  Copyright(c) 1998-2001 Takezou  All rights reserved.
 *  Copyright(c) 2001-2003 Ohtaka(Kazuyoshi Ohta)  All rights reserved.
 *
 *  ̃R|[lg2001N9SĂ̒쌠TakezouOhtaka
 *  ҍӂ̏n܂
 *
 *   99.01.18 Delphi4Ή
 *   99.04.30 RpCw߂ύX
 *   99.11.20 Stretch=falseȂoOC
 *   01.06.20 TLRImage.SetPicture\bh̃oOC
 *}
{
  2001/10/26 TNkDIB(*.dib)̃C[WɑΉ
}

{$INCLUDE DelphiVer.inc}  // Delphi o[Wf̒`

unit LightRepEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, Printers, LightRep, JPEG, NkDIB
  {$IFDEF VER185}, GIFImg{$ENDIF}{, PNGImage};

{TLRImage}
type
  TLRImage = class(TCustomLRItem)
  private
    FPicture: TPicture;
    FStretch: boolean;
    procedure SetPicture(Value: TPicture);
    procedure SetStretch(Value: boolean);
  protected
    function CanAutoSize(var NewWidth, NewHeight: Integer): boolean; override;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Print(ACanvas: TCanvas; Rect: TRect;
      APrintScale: Double; APrintStatus: TPrintStatus); override;
  published
    property AutoSize;
    property Picture: TPicture read FPicture write SetPicture;
    property Stretch: boolean read FStretch write SetStretch;
  end;

implementation

{ TLRImage }

const
  LRERR_INVALID_IMAGE = 'T|[gĂȂ摜tH[}bgł';

constructor TLRImage.Create(AOwner: TComponent);
begin
  inherited;
  FPicture := TPicture.Create;
end;

procedure TLRImage.SetPicture(Value: TPicture);
begin
  // LȃOtBbNȊȌꍇ̓G[
  if (Value = nil) or
     (Value.Graphic = nil) or
     (Value.Graphic is TBitmap) or
     (Value.Graphic is TMetaFile) or
     (Value.Graphic is TNkDIB) or
     (Value.Graphic is TJPEGImage) or 
     {$IFDEF VER185}
     (Value.Graphic is TGIFImage) or  // D2007 or later
     {$ENDIF}
//   (Value.Graphic is TPNGImage) or  // http://pngdelphi.sourceforge.net/
     (Value.Graphic is TNkDIB) then
  begin
    FPicture.Assign(Value);
    Invalidate;
  end
  else
    raise exception.Create(LRERR_INVALID_IMAGE);
end;

procedure TLRImage.SetStretch(Value: boolean);
begin
  if FStretch <> Value then
  begin
    FStretch := Value;
    Invalidate;
  end;
end;

function TLRImage.CanAutoSize(var NewWidth, NewHeight: Integer): boolean;
begin
  Result := True;
  if not (csDesigning in ComponentState) or (Picture.Width > 0) and
    (Picture.Height > 0) then
  begin
    if Align in [alNone, alLeft, alRight] then
      NewWidth := Picture.Width;
    if Align in [alNone, alTop, alBottom] then
      NewHeight := Picture.Height;
  end;
end;

procedure TLRImage.Paint;
begin
  // C[Wꍇ̓C[W`Aꍇ͘g`
  if (FPicture = nil) or (FPicture.Graphic = nil) or (FPicture.Graphic.Empty) then
    with Canvas do
    begin
      // Rg[`ʂ
      TextOut(4, 4, Name);
      // yύX
      Pen.Color := clGreen;
      Pen.Style := psDot;
      // lp``ʂ
      MoveTo(0, 0);
      LineTo(Width-1, 0);
      LineTo(Width-1, Height-1);
      LineTo(0, Height-1);
      LineTo(0, 0);
    end
  else
    if FStretch then
      Canvas.StretchDraw(GetClientRect, FPicture.Graphic)
    else
      Canvas.Draw(0, 0, FPicture.Graphic)
end;

destructor TLRImage.Destroy;
begin
  FPicture.Free;
  inherited;
end;

procedure TLRImage.Print(ACanvas: TCanvas; Rect: TRect;
      APrintScale: Double; APrintStatus: TPrintStatus);
var
  Info: PBitmapInfo;
  {$IFDEF Delphi4Over}
  InfoSize: Cardinal;
  ImageSize: Cardinal;
  {$ELSE}
  InfoSize: integer;
  ImageSize: integer;
  {$ENDIF}
  Image: Pointer;
  DstRect: TRect;
begin
  // tOpsNormalȊȌꍇƁAC[Wꍇ͉Ȃ
  if (APrintStatus <> psNormal) or
     (FPicture.Graphic = nil) or
     (FPicture.Graphic.Empty) then Exit;

  if (FPicture.Graphic is TMetaFile) then
    begin
      // TCỸXP[ɕϊ
      DstRect := PrintScaleRect(Rect, APrintScale);

      // [摜 Metafile ̏ꍇ]
      // ڏo͂
      ACanvas.StretchDraw(DstRect, (FPicture.Graphic as TMetaFile));
    end
  else
    begin
      // [摜 Metafile ȊȌꍇ]
      // rbg}bvɈUOtBbNRs[ADIBɕϊďo͂
      with TBitmap.Create do
      try
        Assign(FPicture.Graphic);

        // Strechfalse̎́ATCY𒲐B
        if not FStretch then
        begin
          if Width > Rect.Right - Rect.Left then
            Width := Rect.Right - Rect.Left
          else
            Rect.Right := Width + Rect.Left;
          if Height > Rect.Bottom - Rect.Top then
            Height := Rect.Bottom - Rect.Top
          else
            Rect.Bottom := Height + Rect.Top;  
        end;

        // TCỸXP[ɕϊ
        DstRect := PrintScaleRect(Rect, APrintScale);

        GetDIBSizes(Handle, InfoSize, ImageSize);
        Info := VirtualAlloc(nil, InfoSize,
          MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
        try
          Image := VirtualAlloc(nil, ImageSize,
            MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
          try
            GetDIB(Handle, Palette, Info^, Image^);
            with Info^.bmiHeader do
            begin
              StretchDIBits(ACanvas.Handle, DstRect.Left, DstRect.Top,
                DstRect.Right - DstRect.Left, DstRect.Bottom - DstRect.Top,
                0, 0, biWidth, biHeight, Image, Info^, DIB_RGB_COLORS, SRCCOPY);
            end;
          finally
            VirtualFree(Image, 0, MEM_RELEASE);
          end;
        finally
          VirtualFree(Info, 0, MEM_RELEASE);
        end;
      finally
        Free;
      end;
    end;
end;

end.
