﻿{*
 *
 *  LightReport2 コンポーネント(Ver 2.5.1)
 *
 *  Copyright(c) 1998-2001 Takezou  All rights reserved.
 *  Copyright(c) 2001-2003 Ohtaka(Kazuyoshi Ohta)  All rights reserved.
 *
 *  このコンポーネントは2001年9月より全ての著作権がTakezouからOhtakaに
 *  両者合意の上譲渡されました
 *
 *
 *  LightReportのソースコードを全面的に書き直し機能を大幅に強化
 *  旧LightReportとの互換性が無くなってしまった（パネルの考え方が変わったため）
 *  ので、クラス名も全て変更し、新しいコンポネントとして作成。
 *
 *  このコンポーネントは、ソースコードも含めてフリーです。
 *  配布は自由に行っていただいてかまいません。
 *  改変・拡張・商用利用・転載も自由ですが、転載される場合は事後でかまいません
 *  ので連絡をもらえるとありがたいです。
 *
 *  修正履歴
 *    Ver 2.01   1998.11.25 PaperSizeにpsNoneを追加
 *    Ver 2.02   1999.01.05 PaperSizeとTLRAlignの列挙型の順番を変更
 *    Ver 2.1    1999.01.10 余白を考慮して、正確なサイズで印刷を行うように修正
 *                   (T.NakamuraさんのNKPrinterを参考にさせていただきました。）
 *                          印刷可能な用紙サイズの追加と例外処理の変更
 *    Ver 2.1.2  1999.01.18 Delphi4対応
 *                          TLRItemのFontが変更された時にParentFontがFalseになら
 *                          ないバグを修正
 *    Ver 2.1.3  1999.02.05 TLRSubPanelの追加
 *    Ver 2.1.3a 1999.02.07 TLRSubPanel関連のバグを修正
 *    Ver 2.1.3b 1999.04.30 条件コンパイル文を変更
 *    Ver 2.1.4  1999.07.30 TGridPanelの印刷方向プロパティを追加
 *                          C++Builder対応のため、一部プロパティの変更
 *    Ver 2.1.5  1999.11.19 LRImageのバグ(Stretchをfalseにしても反映されない)
 *                          を修正
 *    Ver 2.2    2000.03.22 LRVariableText,LRPostBarItemを追加
 *    Ver 2.2.1  2000.05.05 LRVariableTextのバグ修正、条件コンパイル文の修正
 *    Ver 2.2.2  2000.08.24 AfterPrintイベントの追加--DB対応用(Ohtaka様)
 *    Ver 2.2.3  2000.12.02 PDFWriterを使用して印刷したときに背景色がグレーになる
 *                          不具合の修正（長町 章夫 様）
 *               2001.06.20 ドキュメントがAcrobat5で開けない不具合の修正
 *               2001.06.28 Delphi6対応
 *}

{
  ver 2.3.0  2001/09/08 Takezou 氏からメンテナとしての依頼を受け大変うれしくて
                        ふたつ返事ですぐに引き受け、自分の誕生日からメンテナン
                        スを開始する。
                        取り敢えず、これまで自分なりに改良？して使用していた部
                        分をオリジナルソースに加える事から取り掛かる。
  ver 2.3.1  2001/10/10 ドキュメント類を整理し公開
                        以下の修正を加えた
           [
             2000/09/15  ページ指定印刷機能を追加
                         (TLRPreviewControl でプレビューのコントロールを実現)
             2000/09/18  用紙情報設定の不具合に対処
             2000/10/03  スプール容量が大きい場合、分割出力に対応するように
                         機能追加
             2000/10/04  Enabled プロパティを追加して印字有無のコントロールを
                         行うように変更
                         (TCustomLRPanel, TCustomLRItem)
             2000/10/21  印刷スケールの取得方法を変更
                         nifty:FDELPHI/MES/16/00331 を参考にしました
             2000/11/08  LRItem 設計時に枠を表示するよう変更
            ]
  ver 2.3.2  2001/10/15 TLRItem動的生成時縮小プレビューが表示されない場合がある
                        ため対処 [Prophet さん からの情報です(感謝)]
                        (GetMem -> VirtialAlloc, FreeMem -> VirtualFree に変更)
             2001/10/15 PrintMode プロパティを追加
             2001/10/15 FPanelList: TList; は未使用のため削除
  ver 2.4.1  2001/10/20 総ページ数取得用に以下のメソッドとプロパティを追加
                        BeginPaginate, EndPaginate, Paginate メソッド
                        TotalPages プロパティ
             2001/10/26 ScaledPreview メソッドを追加
                        (SmallPreview に PixelFormat パラメータを追加したもの)
                        TLRImage に TNkDIB(*.dib) 対応を追加
             2001/10/30 TLRChildPanel, TLRSubPanel 上に TLRLayoutPanel を置ける
                        よう変更
  ver 2.4.2  2002/02/07 TLRItemR に対角線を引けるように機能追加
                        以下のプロパティを追加
                        DiagonalRisedLeft: TLineStyle  左上がりの対角線
                        DiagonalRisedRight: TLineStyle  右上がりの対角線
  ver 2.4.2a 2002/07/10 サンプル BaseLRepU.pas の不具合を修正
                        samples\base\remained.txt を参照
             2002/09/05 PaperSize プロパティで設定される設計サイズの誤り(psB4)
                        を修正
  ver 2.5.0  2002/10/01 Delphi7 対応
                        DelphiVer.inc でバージョン判断を行うよう変更
  ver 2.5.1  2003/05/12 TLRItem の Text で「&」にてアクセラレータ文字の扱いに
                        ならないよう対処
             2003/05/12 TLRPreviewControl でのメモリリークを解決
}

unit LightRep;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, Printers, Mask, MaskUtils, LRConsts;

type
  { 各種定数の定義 }
  TLineStyle = (lsNone, lsSingle, lsHalf, lsDouble);
  TPrintStatus = (psNormal, psLineOnly, psEndNow);
  TPrintMode = (pmNone, pmPrint, pmPreview, pmPaginate);
  TPaperSize = (psNone, psA4, psB4, psB5, psA3, psA5);
  TLRAlign = (laTop, laLeft, laRight, laBottom, laClient);
  TTextLayout = (tlTop, tlCenter, tlBottom);
  TPrintDirection = (pdHorz, pdVert, pdHolz);  // pdHorzが正しい。互換性のため pdHolz を残します。

  { 各種イベントの定義}
  TBeforePrintEvent = procedure(Sender: TObject;
    Rect: TRect; var Status: TPrintStatus) of object;
  TPrintPanelEvent = procedure(Sender: TObject; ACol, ARow: integer;
    Rect: TRect; var Status: TPrintStatus) of object;

  { TCustomLRPanelコンポネント }
  TCustomLRPanel = class;

  { TLightRepコンポネント }
  {$IF CompilerVersion >= 23.0}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$IFEND}
  TLightRep = class(TCustomPanel)
  private
    FOnSetPrinter: TNotifyEvent;
    FMarginTop: integer;
    FMarginLeft: integer;
    FMarginRight: integer;
    FMarginBottom: integer;
    FOrientation: TPrinterOrientation;
    FPaperSize: TPaperSize;
    FPreviewPageNumber: integer;
    FPrinter: TPrinter;
    FPrintCanvas: TCanvas;
    FPrintMode: TPrintMode;
    FPrintScale: double;
    FSaveSize: TPoint;
    FTitle: TCaption;
    FFirstPage: Integer;
    FLastPage: Integer;
    FDummyBitmap: TBitmap;
    FOldPrinterIndex: Integer;
    FLargeMode: Boolean;
    FTotalPages: Integer;
    procedure ChangeFormSize;
    function GetPageNumber: integer;
    function GetPrinter: TPrinter;
    procedure SetOrientation(Value: TPrinterOrientation);
    procedure SetPaperSize(Value: TPaperSize);
    procedure SetPrinterStatus;
    function GetPrintMode: TPrintMode;
    function GetTotalPages: Integer;
  protected
    procedure AlignControls(AControl: TControl; var ARect: TRect); override;
    procedure Loaded; override;
    procedure Paint; override;
    procedure PrintItem;
    procedure Resize; override;
    procedure SetMarginTop(Value: integer);
    procedure SetMarginLeft(Value: integer);
    procedure SetMarginRight(Value: integer);
    procedure SetMarginBottom(Value: integer);
    procedure SetParent(AParent: TWinControl); override;
    procedure SetPrinter(Value: TPrinter);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure BeginDoc;
    procedure BeginPreview;
    procedure EndDoc;
    procedure EndPreview;
    procedure BeginLargeMode;
    procedure NewPage;
    procedure Preview(ACanvas: TCanvas);
    procedure SmallPreview(ACanvas: TCanvas; X, Y: integer; Scale: integer);
    procedure ScaledPreview(ACanvas: TCanvas; X, Y: integer; Scale: integer; APixelFormat: TPixelFormat);
    procedure Print;
    procedure BeginPaginate;
    procedure Paginate;
    procedure EndPaginate;
    procedure StretchDIBDraw(Rect: TRect; Graphic: TGraphic);
    procedure TextRect(Rect: TRect; X, Y: Integer; const Text: string; Font: TFont);
    function GetVersionText: string;
    property PageNumber: Integer read GetPageNumber;
    property Printer: TPrinter read GetPrinter write SetPrinter;
    property PrintCanvas: TCanvas read FPrintCanvas;  // C++Builder対応のため、Publicに
    property PrintMode: TPrintMode read GetPrintMode;
    property TotalPages: Integer read GetTotalPages;
  published
    property OnSetPrinter: TNotifyEvent read FOnSetPrinter write FOnSetPrinter;
    property MarginTop: integer read FMarginTop write SetMarginTop;
    property MarginLeft: integer read FMarginLeft write SetMarginLeft;
    property MarginRight: integer read FMarginRight write SetMarginRight;
    property MarginBottom: integer read FMarginBottom write SetMarginBottom;
    property Orientation: TPrinterOrientation read FOrientation write SetOrientation;
    property PaperSize: TPaperSize read FPaperSize write SetPaperSize;
    property Title: TCaption read FTitle write FTitle;
    property Visible;
    property FirstPage: Integer read FFirstPage write FFirstPage;
    property LastPage: Integer read FLastPage write FLastPage;
  end;

  { TCustomLRPanel }
  TCustomLRPanel = class(TCustomPanel)
  private
    FAfterPrint: TNotifyEvent;
    FBeforePrint: TBeforePrintEvent;
    procedure SetLRAlign(Value: TLRALign);
    function GetLRAlign: TLRALign;
  protected
    procedure Paint; override;
    procedure Print(ACanvas: TCanvas; ARect: TRect; PrintScale: double); virtual;
    function GetLRRect: TRect;
    function GetLightRep: TLightRep;
    property AfterPrint: TNotifyEvent read FAfterPrint write FAfterPrint;
    property BeforePrint: TBeforePrintEvent read FBeforePrint write FBeforePrint;
    property LRAlign: TLRAlign read GetLRAlign write SetLRAlign;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Font;
    property ParentFont;
    property Enabled;
  end;

  { TLRLayoutPanel }
  {$IF CompilerVersion >= 23.0}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$IFEND}
  TLRLayoutPanel = class(TCustomLRPanel)
  protected
    procedure SetParent(AParent: TWinControl); override;
    procedure Print(ACanvas: TCanvas; ARect: TRect; PrintScale: double); override;
  published
    property AfterPrint;
    property BeforePrint;
    property LRAlign;
  end;

  { TLRChildPanel }
  TLRChildPanel = class(TCustomLRPanel)
  protected
    procedure PrintItem(ACanvas: TCanvas; ARect: TRect;
      PrintScale: double; PrintStatus: TPrintStatus);
  published
    property AfterPrint;
    property BeforePrint;
  end;

  { TLRGridPanel }
  {$IF CompilerVersion >= 23.0}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$IFEND}
  TLRGridPanel = class(TCustomLRPanel)
  private
    FOnPrintPanel: TPrintPanelEvent;
    FColCount: integer;
    FRowCount: integer;
    FChildPanel: TLRChildPanel;
    FSubPanels: TList;
    FReplacePanel: TLRChildPanel;
    FPrintDirection: TPrintDirection;
    procedure SetColCount(Value: integer);
    procedure SetRowCount(Value: integer);
    procedure SetReplacePanel(Value: TLRChildPanel);
    function GetAfterPrintPanel: TNotifyEvent;
    function GetBeforePrintPanel: TBeforePrintEvent;
    procedure SetAfterPrintPanel(const Value: TNotifyEvent);
    procedure SetBeforePrintPanel(const Value: TBeforePrintEvent);
  protected
    procedure Print(ACanvas: TCanvas; ARect: TRect; PrintScale: double); override;
    procedure AlignControls(AControl: TControl; var ARect: TRect); override;
    procedure Paint; override;
    procedure SetParent(AParent: TWinControl); override;
    procedure AddSubPanel(Value: TLRChildPanel);
    procedure RemoveSubPanel(Value: TLRChildPanel);
    procedure ResizeSubPanels(Width, Height: integer);
    procedure Resize; override;
    function GetChildParent: TComponent; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;
    property ReplacePanel: TLRChildPanel read FReplacePanel write SetReplacePanel;
    property LRChildPanel: TLRChildPanel read FChildPanel;
  published
    property AfterPrint;
    property AfterPrintPanel: TNotifyEvent read GetAfterPrintPanel write SetAfterPrintPanel;
    property BeforePrint;
    property BeforePrintPanel: TBeforePrintEvent read GetBeforePrintPanel write SetBeforePrintPanel;
    property ColCount: integer read FColCount write SetColCount;
    property RowCount: integer read FRowCount write SetRowCount;
    property LRAlign;
    property PrintDirection: TPrintDirection read FPrintDirection write FPrintDirection;
    property OnPrintPanel: TPrintPanelEvent read FOnPrintPanel write FOnPrintPanel;
  end;

  { TLRSubPanel }
  {$IF CompilerVersion >= 23.0}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$IFEND}
  TLRSubPanel = class(TLRChildPanel)
  private
    FGridPanel: TLRGridPanel;
    procedure SetGridPanel(Value: TLRGridPanel);
  protected
    procedure SetParent(AParent: TWinControl); override;
    procedure Resize; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property GridPanel: TLRGridPanel read FGridPanel write SetGridPanel;
  end;

  { TCustomLRItem }
  TCustomLRItem = class(TGraphicControl)
  private
    FFocusControl: TWinControl;
    procedure SetFocusControl(Value: TWinControl);
  protected
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure Print(ACanvas: TCanvas; ARect: TRect;
      APrintScale: double; APrintStatus: TPrintStatus); virtual;
    procedure SetParent(AParent: TWinControl); override;
    property FocusControl: TWinControl read FFocusControl write SetFocusControl;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Align;
    property Enabled;
  end;

  { TLRItem }
  {$IF CompilerVersion >= 23.0}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$IFEND}
  TLRItem = class(TCustomLRItem)
  private
    FAlignment: TAlignment;
    FEditMask: string;
    FHMargin: integer;
    FLayout: TTextLayout;
    FLineColor: TColor;
    FShapeTop: TLineStyle;
    FShapeLeft: TLineStyle;
    FShapeRight: TLineStyle;
    FShapeBottom: TLineStyle;
    FTransParent: boolean;
    FVMargin: integer;
    FWordWrap: Boolean;
    procedure SetAlignment(Value: TAlignment);
    procedure SetEditMask(Value: string);
    procedure SetHMargin(Value: integer);
    procedure SetLayout(Value: TTextLayout);
    procedure SetLineTop(Value: TLineStyle);
    procedure SetLineLeft(Value: TLineStyle);
    procedure SetLineRight(Value: TLineStyle);
    procedure SetLineBottom(Value: TLineStyle);
    procedure SetLineStyle(Canvas: TCanvas; Style: TLineStyle; PrintScale: double);
    procedure SetText(Value: string);
    procedure SetTransParent(Value: boolean);
    procedure SetVMargin(Value: integer);
    procedure SetWordWrap(Value: Boolean);
    function GetDiaplayText: string;
    function GetText: string;
  protected
    procedure Paint; override;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure Print(ACanvas: TCanvas; ARect: TRect;
      APrintScale: double; APrintStatus: TPrintStatus); override;
  published
    constructor Create(AOwner: TComponent); override;
    property Alignment: TAlignment read FAlignment write SetAlignment
      default taLeftJustify;
    property Color;
    property DisplayMask: string read FEditMask write SetEditMask;
    property Font;
    property HMargin: integer read FHMargin write SetHMargin default 1;
    property Layout: TTextLayout read FLayout write SetLayout default tlTop;
    property LineColor: TColor read FLineColor write FLineColor;
    property LineTop: TLineStyle read FShapeTop write SetLineTop;
    property LineLeft: TLineStyle read FShapeLeft write SetLineLeft;
    property LineRight: TLineStyle read FShapeRight write SetLineRight;
    property LineBottom: TLineStyle read FShapeBottom write SetLineBottom;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property Text: string read GetText write SetText;
    property Transparent: boolean read FTransparent write SetTransparent;
    property VMargin: integer read FVMargin write SetVMargin default 1;
    property WordWrap: Boolean read FWordWrap write SetWordWrap default False;
  end;

  {例外の定義}
  ELRError = class(Exception);

  {共通ルーチン}
  procedure PaintGrid(Canvas: TCanvas; Width, Height: integer;
    OffsetX, OffsetY: integer);
  function ToPrintScale(Value: integer; APrintScale: double): integer;
  function PrintScaleRect(ARect: TRect; APrintScale: double): TRect;
  // 設計時枠表示のため
  procedure DrowDesignFrame(ACanvas: TCanvas; Color: TColor; ARect: TRect;
    LineLeft, LineTop, LineRight, LineBottom: TLineStyle);

implementation

const
  LINE_PITCH: integer = 378; // 378ドッド = 10センチ
  LINE_COLOR: TColor = clSilver;
  PROTECT_AREA_COLOR: TColor = $00EFEFEF;
  MIN_PANEL_SIZE = 10;

{共通ルーチン}

// PaintGrid グリッドの描写
procedure PaintGrid(Canvas: TCanvas; Width, Height: integer;
  OffsetX, OffsetY: integer);
var
  LinePos: integer;
  LineCount: integer;
  LineFlg: boolean;
  // 画面にグリッドを描写するためのペンの設定を行うサブブロック
  procedure SetPen(Canvas: TCanvas; flg: boolean);
  begin
    Canvas.Pen.Color := LINE_COLOR;
    if flg then
      Canvas.Pen.Style := psSolid
    else
      Canvas.Pen.Style := psDot;
  end;
begin
  with Canvas do
  begin
    // まず縦線を書く
    LineCount := 0;
    LineFlg := true;
    LinePos := - OffsetX;
    while LinePos < Width do
    begin
      if LinePos > 0 then
      begin
        MoveTo(LinePos, 0);
        // 実線と破線を交互に描写する
        SetPen(Canvas, LineFlg);
        LineTo(LinePos, Height - 1);
      end;
      inc(LineCount);
      LineFlg := not LineFlg;
      LinePos := trunc(LineCount * LINE_PITCH / 20) - OffsetX;
    end;

    // 横線を書く
    LineCount := 0;
    LineFlg := true;
    LinePos := - OffsetY;
    while LinePos < Height do
    begin
      if LinePos > 0 then
      begin
        MoveTo(0, LinePos);
        SetPen(Canvas, LineFlg);
        LineTo(Width - 1, LinePos);
      end;
      inc(LineCount);
      LineFlg := not LineFlg;
      LinePos := trunc(LineCount * LINE_PITCH / 20) - OffsetY;
    end;
  end;
end;

// ToPrintScale Valueの値を印刷画面のスケールに変換
function ToPrintScale(Value: integer; APrintScale: double): integer;
begin
  result := Trunc(Value * APrintScale);
end;

// PrintScaleRect ARectで渡されたRectを印刷画面のスケールに変換
function PrintScaleRect(ARect: TRect; APrintScale: double): TRect;
begin
  // Rectを印刷面のスケールに変換する
  result.Top := ToPrintScale(ARect.Top, APrintScale);
  result.Left := ToPrintScale(ARect.Left, APrintScale);
  result.Right := ToPrintScale(ARect.Right, APrintScale);
  result.Bottom := ToPrintScale(ARect.Bottom, APrintScale);
end;

// 設計時に枠線を描画する
procedure  DrowDesignFrame(ACanvas: TCanvas; Color: TColor; ARect: TRect;
  LineLeft, LineTop, LineRight, LineBottom: TLineStyle);
const
  FrameLineSize = 4;
begin
   if  Color = clWhite  then
    with  ACanvas  do
    begin
      // 識別用の枠線を描写 罫線がある場合は表示しない
      Pen.Color := clGreen;
      if  (LineTop = lsNone) and (LineLeft = lsNone)
      and (LineBottom = lsNone) and (LineRight = lsNone)  then
        begin
          // 左上
          MoveTo(ARect.Left, ARect.Top + FrameLineSize);
          LineTo(ARect.Left, ARect.Top);
          LineTo(ARect.Left + FrameLineSize, ARect.Top);
          // 右上
          MoveTo(ARect.Right - 1, ARect.Top + FrameLineSize);
          LineTo(ARect.Right - 1, ARect.Top);
          LineTo(ARect.Right - 1 - FrameLineSize, ARect.Top);
          // 左下
          MoveTo(ARect.Left, ARect.Bottom - 1 - FrameLineSize);
          LineTo(ARect.Left, ARect.Bottom - 1);
          LineTo(ARect.Left + FrameLineSize, ARect.Bottom - 1);
          // 右下
          MoveTo(ARect.Right - 1 - FrameLineSize, ARect.Bottom - 1);
          LineTo(ARect.Right - 1, ARect.Bottom - 1);
          LineTo(ARect.Right - 1, ARect.Bottom - 1 - FrameLineSize);
        end;
    end;
end;

{TLightRep}

// TLightRep.Create
constructor TLightRep.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPrinter := nil;
  BevelOuter := bvRaised;
  BevelWidth := 1;
  Color := clWhite;
  FPreviewPageNumber := 0;
  FPrintMode := pmNone;
  FMarginLeft := LINE_PITCH div 10 - 1;
  FMarginRight := LINE_PITCH div 10 - 1;
  FMarginTop := LINE_PITCH div 10 - 1;
  FMarginBottom := LINE_PITCH div 10 - 1;
  PaperSize := psA4;
  FOldPrinterIndex := Printer.PrinterIndex;
  FLargeMode := False;
  FTotalPages := -1;
end;

procedure TLightRep.Loaded;
begin
  inherited;
  // 設計時以外は非表示
  if not (csDesigning in ComponentState) then
    Visible := false;
end;

// TLightRep.destroy
destructor TLightRep.destroy;
begin
//
  inherited;
end;

// TLightRep.ChangeFormSize 用紙サイズ・向きが変わったときにパネルの大きさを変更する
procedure TLightRep.ChangeFormSize;
  function ReversePoint(Value: TPoint): TPoint;
  begin
    result.x := Value.y;
    result.y := Value.x;
  end;
begin
  case FPaperSize of
    // psNoneの時は、サイズに応じてOrientationを変更
    psNone: Exit;
    psA3: FSaveSize := Point(1123, 1587);
    psA4: FSaveSize := Point(794, 1123);
    psB4: FSaveSize := Point(971, 1376);
    psA5: FSaveSize := Point(559, 794);
    psB5: FSaveSize := Point(688, 971);
  end;
  if FOrientation <> poPortrait then
    FSaveSize := ReversePoint(FSaveSize);
  if (Width <> FSaveSize.x) or (Height <> FSaveSize.y) then
    SetBounds(Left, Top, FSaveSize.x, FSaveSize.y);
end;

// TLightRep.SetPrinterStatus プリンタの用紙サイズ・印刷方向をセットする
procedure TLightRep.SetPrinterStatus;
var
  PrinterName, DriverName, PortName:array[0..255] of Char;
  S: string;
  DeviceMode: THandle;
  DevModeW: ^TDevMode;
begin
  // 用紙サイズのセットがうまく出来ないプリンター用に対処
  if  FOldPrinterIndex <> Printer.PrinterIndex  then
    begin
      StrPCopy(PortName, '');
      Printer.GetPrinter(DriverName, PrinterName, PortName, DeviceMode);
      Printer.SetPrinter(DriverName, PrinterName, PortName, 0);
      FOldPrinterIndex := Printer.PrinterIndex;
    end;

  if FPaperSize = psNone then
  begin
    if Assigned(FOnSetPrinter) then FOnSetPrinter(Self);
    Exit;
  end;

  StrPCopy(DriverName, '');
  S := Printer.Printers[Printer.PrinterIndex];
  if Pos('.', S) > 0 then
    S := Copy(S, 1, Pos('.', S)-1);
  StrPCopy(PrinterName, S);

  StrPCopy(PortName, '');
  Printer.GetPrinter(DriverName, PrinterName, PortName, DeviceMode);
  DevModeW := GlobalLock(DeviceMode);
  if DevModeW = nil then
    raise ELRError.Create(LRERR_PAPERSETTING);
  case FPaperSize of
    psA3: DevModeW.dmPaperSize := DMPAPER_A3;
    psA4: DevModeW.dmPaperSize := DMPAPER_A4;
    psA5: DevModeW.dmPaperSize := DMPAPER_A5;
    psB4: DevModeW.dmPaperSize := DMPAPER_B4;
    psB5: DevModeW.dmPaperSize := DMPAPER_B5;
  end;
  if FOrientation = poPortrait then
    DevModeW.dmOrientation := DMORIENT_PORTRAIT
  else
    DevModeW.dmOrientation := DMORIENT_LANDSCAPE;
  GlobalUnlock(DeviceMode);
  Printer.SetPrinter(DriverName, PrinterName, PortName, DeviceMode);
end;

// TLightRep.SetPaperSize
procedure TLightRep.SetPaperSize(Value: TPaperSize);
begin
// 用紙の大きさが変更されたら、コントロールの大きさを変更する
  if FPaperSize <> Value then
  begin
    FPapersize := Value;
    ChangeFormSize;
  end;
end;

// TLightRep.SetOrientation
procedure TLightRep.SetOrientation(Value: TPrinterOrientation);
begin
// 用紙の向きが変更されたら、コントロールの大きさを変更する
  if FOrientation <> Value then
  begin
    FOrientation := Value;
    // コンポーネントがロード中でない時はフォームのサイズを変更
    if not (csReading in ComponentState) then
      ChangeFormSize;
  end;
end;

// TLightRep.SetParent
procedure TLightRep.SetParent(AParent: TWinControl);
begin
// コントロールはフォーム直下にしか配置できない。
  if (AParent <> nil) and not (AParent is TForm) then
    raise ELRError.Create(LRERR_INVALID_PARENT1);
  inherited SetParent(AParent);
end;

// SetMarginTop～SetMarginBottom 余白が変更されたらパネルを再配置する
procedure TLightRep.SetMarginTop(Value: integer);
var
  Rect: TRect;
begin
  if (FMarginTop <> Value) and (Value > 0) and (Value < Width div 2) then
  begin
    Rect := ClientRect;
    FMarginTop := Value;
    AlignControls(nil, Rect);
  end;
end;

procedure TLightRep.SetMarginLeft(Value: integer);
var
  Rect: TRect;
begin
  if (FMarginLeft <> Value) and (Value > 0) and (Value < Width div 2) then
  begin
    Rect := ClientRect;
    FMarginLeft := Value;
    AlignControls(nil, Rect);
  end;
end;

procedure TLightRep.SetMarginRight(Value: integer);
var
  Rect: TRect;
begin
  if (FMarginRight <> Value) and (Value > 0) and (Value < Width div 2) then
  begin
    Rect := ClientRect;
    FMarginRight := Value;
    AlignControls(nil, Rect);
  end;
end;

procedure TLightRep.SetMarginBottom(Value: integer);
var
  Rect: TRect;
begin
  if (FMarginBottom <> Value) and (Value > 0) and (Value < Width div 2) then
  begin
    Rect := ClientRect;
    FMarginBottom := Value;
    AlignControls(nil, Rect);
  end;
end;

// TLightRep.Resize
procedure TLightRep.Resize;
begin
  // PaperSizeがpsNone以外の時はサイズ変更は不可
  if (FPaperSize = psNone) or (csReading in ComponentState) then
  begin
    inherited;
    Exit;
  end;

  if Width <> FSaveSize.x then Width := FSaveSize.x;
  if Height <> FSaveSize.y then Height := FSaveSize.y;
end;

// TLightRep.GetPrinter
function TLightRep.GetPrinter: TPrinter;
begin
  if FPrinter = nil then
    Printer := Printers.Printer;
  Result := FPrinter;
end;

// TLightRep.SetPrinter
procedure TLightRep.SetPrinter(Value: TPrinter);
begin
  if Value <> nil then
    FPrinter := Value;
end;

// TLightRep.BeginDoc
procedure TLightRep.BeginDoc;
begin
  case FPrintMode of
    // 印刷中だったらエラー
    pmPrint: raise ELRError.Create(LRERR_PRINTER_NOT_READY1);
    // プレビュー中だったらプレヴューを終了
    pmPreview: EndPreview;
    // Paginate中だったらエラー
    pmPaginate: raise ELRError.Create(LRERR_Paginate_CANNOT_PRINT);
  end;
  // ページ指定印刷のためエラーチェック
  if  (FLastPage <> 0) and (FFirstPage > FLastPage)  then
    begin
      FLastPage := FFirstPage;
      raise ELRError.Create(LRERR_INVALID_PRINTPAGERANGE);
    end;
  // プリンタを設定
  SetPrinterStatus;
  // プリンターのキャンバスを設定
  FPrintCanvas := Printer.Canvas;
  // タイトルを設定
  Printer.Title := FTitle;
  // 印刷開始
  Printer.BeginDoc;
  FPrintMode := pmPrint;
  // ページ指定印刷のため
  if  not FLargeMode  then  FPreviewPageNumber := 0;  // 分割出力対応のため
  if  ((FFirstPage > 1) or (FLastPage > 0))
  and (not Assigned(FDummyBitmap))  then
    begin
      FDummyBitmap := TBitmap.Create;
      FDummyBitmap.PixelFormat := pf1bit;
    end;
end;

// TLightRep.BeginPreview
procedure TLightRep.BeginPreview;
begin
  case  FPrintMode  of
    // 印刷中だったらエラー
    pmPrint: raise ELRError.Create(LRERR_CANNOT_BEGIN_PREVIEW);
    // Paginate中だったらエラー
    pmPaginate: raise ELRError.Create(LRERR_Paginate_CANNOT_PREVIEW);
  end;
  // プレヴューを開始する
  FPrintMode := pmPreview;
  FPreviewPageNumber := 0;
end;

// TLightRep.EndDoc
procedure TLightRep.EndDoc;
begin
  if FPrintMode = pmPrint then
  begin
    Printer.EndDoc;
    FPrintMode := pmNone;
  end;
  if  Assigned(FDummyBitmap)  then
    begin
      FDummyBitmap.Free;
      FDummyBitmap := nil;
    end;
end;

// TLightRep.EndPreview
procedure TLightRep.EndPreview;
begin
  FPrintMode := pmNone;
  FPreviewPageNumber := 0;
end;

// TLightRep.NewPage
procedure TLightRep.NewPage;
begin
  if Printer.Printing then
    if  (FFirstPage <= FPreviewPageNumber)
    and ((FLastPage = 0) or (FLastPage > FPreviewPageNumber))  then
      // 最終ページは NewPage を発行しない
      // (白紙が出るタイプのプリンターがあるため)
      Printer.NewPage;
end;

// TLightRep.GetPageNumber
function TLightRep.GetPageNumber;
begin
  case FPrintMode of
    // Print 時にもカウントするように変更
    // スキップページがあるので Printer.PageNumber は使用できない
    pmPrint: Result := FPreviewPageNumber;
    pmPreview: Result := FPreviewPageNumber;
    pmPaginate: Result := FPreviewPageNumber;
  else
    Result := 0;
  end;
end;

// TLightRep.Preview
procedure TLightRep.Preview(ACanvas: TCanvas);
begin
  // フラグがPreviewモードでなかったらPreviewモードに設定
  if  FPrintMode <> pmPreview  then
    BeginPreview;
  // 印刷スケールの設定
  FPrintScale := 1;
  // キャンバスを設定
  FPrintCanvas := ACanvas;
  // 印刷先のキャンバスの初期化
  ACanvas.Brush.Color := clWhite;
  ACanvas.FillRect(Rect(0,0,Width,Height));
  // ページをカウントアップ
  inc(FPreviewPageNumber);
  // パネルを印刷する
  PrintItem;
end;

// TLightRep.SmallPreview 縮小プレビュー
procedure TLightRep.SmallPreview(ACanvas: TCanvas; X, Y: integer;
  Scale: integer);
begin
  ScaledPreview(ACanvas, X, Y, Scale, pfDevice);
end;

// TLightRep.ScaledPreview
procedure TLightRep.ScaledPreview(ACanvas: TCanvas; X, Y, Scale: integer;
  APixelFormat: TPixelFormat);
var
  Bitmap: TBitmap;
  Info: PBitmapInfo;
  InfoSize: Cardinal;
  ImageSize: Cardinal;
  Image: Pointer;
begin
  // Scaleが無効な場合はエラー
  if (Scale < 25) or (Scale > 100) then
    raise ELRError.Create(LRERR_INVALID_SCALE);
  // 一時ビットマップを作成
  Bitmap := TBitmap.Create;
  with Bitmap do
  try
    PixelFormat := APixelFormat;
    Width := Self.Width;
    Height := Self.Height;
    // 一時ビットマップに一旦描画する
    Preview(Canvas);
    // DIBファイルに変換して、キャンバスに縮小して描画する
    GetDIBSizes(Handle, InfoSize, ImageSize);
    Info := VirtualAlloc(nil, InfoSize,
      MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
    try
      Image := VirtualAlloc(nil, ImageSize,
        MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
      try
        GetDIB(Handle, Palette, Info^, Image^);
        with Info^.bmiHeader do
        begin
          StretchDIBits(ACanvas.Handle, X, Y,
            trunc(Width*Scale/100), trunc(Height*Scale/100),
            0, 0, biWidth, biHeight, Image, Info^, DIB_RGB_COLORS, SRCCOPY);
        end;
      finally
        VirtualFree(Image, 0, MEM_RELEASE);
      end;
    finally
      VirtualFree(Info, 0, MEM_RELEASE);
    end;
  finally
    Free;
  end;
end;

// TLightRep.PrintItem
procedure TLightRep.PrintItem;
var
  TmpRect: TRect;
  i: integer;
  OffsetX, OffsetY: integer;
begin
  // パネルを順番に印刷する
  for i := 0 to ControlCount - 1 do
    if Controls[i] is TCustomLRPanel then
      //  印字有無のコントロール用
      if  (csDesigning in ComponentState)
      or  TCustomLRPanel(Controls[i]).Enabled  then
        begin
          TmpRect := Controls[i].BoundsRect;
          // Ver2.1より余白領域を取得してその分だけ領域をずらす。
          if FPrintMode = pmPrint then
          begin
          try
            OffsetX := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETX);
            OffsetY := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETY);
          except
            OffsetX := 0;
            OffsetY := 0;
          end;
          OffsetRect(TmpRect, -Trunc(OffsetX / FPrintScale),
            -Trunc(OffsetY / FPrintScale));
          end;
          TCustomLRPanel(Controls[i]).Print(FPrintCanvas, TmpRect, FPrintScale);
        end;
end;

// TLightRep.Print
procedure TLightRep.Print;
var
  PrinterResultY, MonitorResult :Integer;
  RatioY: Extended;
begin
  // BeginDocが実行されていなかったらエラー
  if FPrintMode = pmNone then
    raise ELRError.Create(LRERR_BEGINDOC_NOTCALLED);
  // ページスキップ用にページをカウントアップ
  Inc(FPreviewPageNumber);
  if  (FFirstPage <= FPreviewPageNumber)
  and ((FLastPage = 0) or (FLastPage >= FPreviewPageNumber))  then
    begin
      // 印刷範囲内は今まで通り印刷先のCanvasをセット
      FPrintCanvas := Printer.Canvas;
      // 印刷スケールの計算
      // プリンター解像度とモニター解像度から印刷スケールを計算する
      try
        //プリンターの解像度を得る(縦)
        PrinterResultY := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
        //モニターの解像度を得る(縦)
        MonitorResult := GetDeviceCaps(Canvas.Handle, LOGPIXELSY);
        //縦の比率を出す。
        RatioY := PrinterResultY / MonitorResult;
        FPrintScale := RatioY;                      // 縦の比率を採用する
      except
        FPrintScale := 1;
      end;
    end
  else
    // 開始ページに達していないか、
    // または、終了ページを過ぎていたらダミーに書いてもらう
    begin
      // 印刷スケールの設定
      FPrintScale := 1;
      // キャンバスを設定
      FPrintCanvas := FDummyBitmap.Canvas;
    end;
  // パネルを印刷する
  PrintItem;
end;

// TLightRep.StretchDIBDraw
procedure TLightRep.StretchDIBDraw(Rect: TRect; Graphic: TGraphic);
var
  Info: PBitmapInfo;
  InfoSize: Cardinal;
  ImageSize: Cardinal;
  Image: Pointer;
  DstRect: TRect;
begin
  if FPrintMode = pmNone then
    raise ELRError.Create(LRERR_INVALID_METHOD);
  // Rectを印刷面のスケールに変換する
  DstRect := PrintScaleRect(Rect, FPrintScale);
  with TBitmap.Create do
  try
    Assign(Graphic);
    GetDIBSizes(Handle, InfoSize, ImageSize);
    Info := VirtualAlloc(nil, InfoSize,
      MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
    try
      Image := VirtualAlloc(nil, ImageSize,
        MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
      try
        GetDIB(Handle, Palette, Info^, Image^);
        with Info^.bmiHeader do
        begin
          StretchDIBits(FPrintCanvas.Handle, DstRect.Left, DstRect.Top,
            DstRect.Right - DstRect.Left, DstRect.Bottom - DstRect.Top,
            0, 0, biWidth, biHeight, Image, Info^, DIB_RGB_COLORS, SRCCOPY);
        end;
      finally
        VirtualFree(Image, 0, MEM_RELEASE);
      end;
    finally
      VirtualFree(Info, 0, MEM_RELEASE);
    end;
  finally
    Free;
  end;
end;

// TLightRep.TextRect
procedure TLightRep.TextRect(Rect: TRect;
  X, Y: Integer; const Text: string; Font: TFont);
var
  DstRect: TRect;
begin
  // Rectを印刷面のスケールに変換する
  DstRect := PrintScaleRect(Rect, FPrintScale);
  FPrintCanvas.Font := Font;
  FPrintCanvas.TextRect(DstRect, ToPrintScale(X, FPrintScale),
    ToPrintScale(Y, FPrintScale), Text);
end;

// TLightRep.Paint
procedure TLightRep.Paint;
var
  LinePos: integer;
  LineCount: Integer;
begin
  inherited Paint;

  with Canvas do
  begin
    // キャンバスを塗りつぶす
    Brush.Color := clWhite;
    FillRect(GetClientRect);
    // まずグリッドを描写する
    PaintGrid(Canvas, Width, Height, 0, 0);
    // フォントの設定
    Font.Size := 8;
    Font.Color := clSilver;
    // 上端、左端のスケール文字の印刷
    LineCount := 0;
    LinePos := 0;
    while LinePos < Width do
    begin
      TextOut(LinePos + 1, 1, IntToStr(LineCount));
      inc(LineCount);
      LinePos := trunc(LineCount * LINE_PITCH / 10);
    end;
    LineCount := 0;
    LinePos := 0;
    while LinePos < Height do
    begin
      TextOut(1, LinePos + 1, IntToStr(LineCount));
      inc(LineCount);
      LinePos := trunc(LineCount * LINE_PITCH / 10);
    end;
    // コントロール名を描写する
    Font := Self.Font;
    TextOut(4, 4, Name);
  end;
end;

// TLightRep.AlignControls
procedure TLightRep.AlignControls(AControl: TControl; var ARect: TRect);
begin
  ARect := Rect(ARect.Left + FMarginLeft, ARect.Top + FMarginTop,
    ARect.Right - FMarginRight, ARect.Bottom - FMarginBottom);
  inherited AlignControls(AControl, ARect);
end;

function TLightRep.GetVersionText: string;
begin
  result := LIGHTREP_VERSION_TEXT;
end;

procedure TLightRep.BeginLargeMode;
begin
  FLargeMode := True;
  FPreviewPageNumber := 0;
end;

function TLightRep.GetPrintMode: TPrintMode;
begin
  Result := FPrintMode;
end;

// 総ページ数取得のための処理
procedure TLightRep.BeginPaginate;
begin
  case FPrintMode of
    // 印刷中だったらエラー
    pmPrint: raise ELRError.Create(LRERR_PRINT_CANNOT_Paginate);
    // プレビュー中だったらプレビューを終了
    pmPreview: EndPreview;
  end;
  FPrintMode := pmPaginate;
  FPreviewPageNumber := 0;
  // ページイメージ描画用のため
  if  not Assigned(FDummyBitmap)  then
    begin
      FDummyBitmap := TBitmap.Create;
      FDummyBitmap.PixelFormat := pf1bit;
    end;
end;

procedure TLightRep.EndPaginate;
begin
  FPrintMode := pmNone;
  if  Assigned(FDummyBitmap)  then
    begin
      FDummyBitmap.Free;
      FDummyBitmap := nil;
    end;
  FTotalPages := FPreviewPageNumber;
  FPreviewPageNumber := 0;
end;

procedure TLightRep.Paginate;
begin
  // BeginPaginateが実行されていなかったらエラー
  if  FPrintMode <> pmPaginate  then
    raise ELRError.Create(LRERR_BEGINPaginate_NOTCALLED);
  // ページスキップ用にページをカウントアップ
  Inc(FPreviewPageNumber);
  // 印刷スケールの設定
  FPrintScale := 1;
  // キャンバスを設定(ダミーに書いてもらう)
  FPrintCanvas := FDummyBitmap.Canvas;
  // パネルを印刷する
  PrintItem;
end;

// Paginate で取得した総ページ数を返す
function TLightRep.GetTotalPages: Integer;
begin
  if  FPrintMode = pmPaginate  then
    Result := 0
  else
    begin
      if  FTotalPages < 0  then
        raise ELRError.Create(LRERR_NOT_Paginate);
      Result := FTotalPages;
    end;
end;

{ TCustomLRPanel }

// TCustomLRPanel.Create
constructor TCustomLRPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Align := alTop;
  Height := 100;
  BevelOuter := bvNone;
  Color := clWindow;
  BorderStyle := bsNone;
end;

// TCustomLRPanel.GetLRRect
function TCustomLRPanel.GetLRRect: TRect;
begin
  // LightReportから見た相対位置を返す
  if (Parent is TCustomLRPanel) then
  begin
    result := TCustomLRPanel(Parent).GetLRRect;
    OffsetRect(result, Left, Top);
  end
  else
    result := Rect(Left, Top, Left+Width, Top+Height);
end;

// TCustomLRPanel.SetLRAlign
procedure TCustomLRPanel.SetLRAlign(Value: TLRAlign);
begin
  if Value <> LRALign then
  begin
    case Value of
      laTop: Align := alTop;
      laLeft: Align := alLeft;
      laRight: Align := alRight;
      laClient: Align := alClient;
      laBottom: Align := alBottom;
    end;
    Invalidate;
  end;
end;

// TCustomLRPanel.GetLRAlign
function TCustomLRPanel.GetLRAlign: TLRALign;
begin
  result := laClient;
  case Align of
    alTop: result := laTop;
    alLeft: result := laLeft;
    alRight: result := laRight;
    alBottom: result := laBottom;
  end;
end;

// TCustomLRPanel.GeTLightRep
function TCustomLRPanel.GeTLightRep: TLightRep;
begin
  // LightReportへの参照を返す
  if (Parent is TCustomLRPanel) then
    result := TCustomLRPanel(Parent).GeTLightRep
  else
  if (Parent is TLightRep) then
    result := TLightRep(Parent)
  else
    result := nil;
end;

// TCustomLRPanel.Paint
procedure TCustomLRPanel.Paint;
var
  TmpRect: TRect;
begin
  with Canvas do
  begin
    // キャンバスの色を設定
    Brush.Color := clWhite;
    FillRect(Rect(0,0,Width,Height));
    // グリッドを描写する
    TmpRect := GetLRRect;
    PaintGrid(Canvas, Width, Height, TmpRect.Left, TmpRect.Top);
    // コントロール名を描写する
    TextOut(2, 2, Name);
    // 輪郭を描写する
    Pen.Color := clBlue;
    Pen.Style := psDot;
    MoveTo(0,0);
    LineTo(Width-1,0);
    LineTo(Width-1,Height-1);
    LineTo(0,Height-1);
    LineTo(0,0);
  end;
end;

// TCustomLRPanel.Print
procedure TCustomLRPanel.Print(ACanvas: TCanvas; ARect: TRect; PrintScale: double);
begin
end;

{ TLRLayoutPanel }

// TLRLayoutPanel.Print
procedure TLRLayoutPanel.Print(ACanvas: TCanvas; ARect: TRect; PrintScale: double);
var
  Status: TPrintStatus;
  tmpRect: TRect;
  i: integer;
begin
  // イベントの発生
  Status := psNormal;
  if Assigned(FBeforePrint) then
    FBeforePrint(Self, ARect, Status);
  // ステイタスがpsEndNowの時は印刷中止
  if Status = psEndNow then Exit;
  // パネル上のコントロールまたはパネルを順番に印刷する。
  for i := 0 to ControlCount - 1 do
  begin
    tmpRect := Controls[i].BoundsRect;
    OffsetRect(tmpRect, ARect.Left, ARect.Top);
    if Controls[i] is TCustomLRItem then
      begin
        //  印字有無のコントロール用
        if  (csDesigning in ComponentState)
        or  TCustomLRItem(Controls[i]).Enabled  then
          TCustomLRItem(Controls[i]).Print(ACanvas, tmpRect, PrintScale, Status);
      end
    else
    if Controls[i] is TCustomLRPanel then
      begin
        //  印字有無のコントロール用
        if  (csDesigning in ComponentState)
        or  TCustomLRPanel(Controls[i]).Enabled  then
          TCustomLRPanel(Controls[i]).Print(ACanvas, tmpRect, PrintScale);
      end;
  end;
  if Assigned(FAfterPrint) then
    FAfterPrint(Self);
end;

// TLRLayoutPanel.SetParent
procedure TLRLayoutPanel.SetParent(AParent: TWinControl);
begin
  if  AParent is TLRGridPanel  then
    AParent := TLRGridPanel(AParent).LRChildPanel;
  if (AParent <> nil) and
   (not (AParent is TLightRep) and not (AParent is TLRLayoutPanel) and
    not (AParent is TLRChildPanel)) then
    raise ELRError.Create(LRERR_INVALID_PARENT2);
  inherited SetParent(AParent);
end;

{ TLRChildPanel }

// TLRChildPanel.PrintItem
procedure TLRChildPanel.PrintItem(ACanvas: TCanvas; ARect: TRect;
      PrintScale: double; PrintStatus: TPrintStatus);
var
  tmpRect: TRect;
  i: integer;
begin
  // パネル上のコントロールを順番に印刷する。
  for i := 0 to ControlCount - 1 do
  begin
    tmpRect := Controls[i].BoundsRect;
    OffsetRect(tmpRect, ARect.Left, ARect.Top);
    if Controls[i] is TCustomLRItem then
      begin
        //  印字有無のコントロール用
        if  (csDesigning in ComponentState)
        or  TCustomLRItem(Controls[i]).Enabled  then
          TCustomLRItem(Controls[i]).Print(
            ACanvas, tmpRect, PrintScale, PrintStatus)
      end
    else
    if Controls[i] is TLRLayoutPanel then
      begin
        //  印字有無のコントロール用
        if  (csDesigning in ComponentState)
        or  TLRLayoutPanel(Controls[i]).Enabled  then
          TLRLayoutPanel(Controls[i]).Print(
            ACanvas, tmpRect, PrintScale);
      end;
  end;
end;

{ TLRGridPanel }

// TLRGridPanel.Create
constructor TLRGridPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FColCount := 1;
  FRowCount := 1;
  FChildPanel := TLRChildPanel.Create(Self);
  FChildPanel.Align := alClient;
  FChildPanel.Parent := Self;
  FSubPanels := TList.Create;
  FSubPanels.Clear;
end;

// TLRGridPanel.Destroy
destructor TLRGridPanel.Destroy;
var
  RelatedPanel: TObject;
  i: integer;
begin
  // 関連したパネルとの関係を削除
  for i := FSubPanels.Count - 1 downto 0 do
  begin
    RelatedPanel := TObject(FSubPanels[i]);
    if (RelatedPanel <> nil) and (RelatedPanel is TLRSubPanel) then
      TLRSubPanel(RelatedPanel).GridPanel := nil;
  end;
  FChildPanel.Free;
  FSubPanels.Free;
  inherited;
end;

// TLRGridPanel.GetChildParent
function TLRGridPanel.GetChildParent: TComponent;
begin
  // LRGridPanel自体は、子コントロールを持たない
  Result := FChildPanel;
end;

// TLRGridPanel.GetChildren
procedure TLRGridPanel.GetChildren(Proc: TGetChildProc; Root: TComponent);
begin
  FChildPanel.GetChildren(Proc, Root);
end;

// TLRGridPanelAlignControls
procedure TLRGridPanel.AlignControls(AControl: TControl; var ARect: TRect);
begin
  if FColCount > 1 then
    ARect.Right := ARect.Left + (ARect.Right-ARect.Left) div ColCount;
  if FRowCount > 1 then
    ARect.Bottom := ARect.Top + (ARect.Bottom-ARect.Top) div RowCount;
  ResizeSubPanels(ARect.Right-ARect.Left, ARect.Bottom-ARect.Top);
  inherited AlignControls(AControl, ARect);
end;

// TLRGridPanel.SetColCount
procedure TLRGridPanel.SetColCount(Value: integer);
var
  Rect: TRect;
begin
  if Value <> FColCount then
  begin
    if (Value < 1) or ((Width div Value) < MIN_PANEL_SIZE) then
      raise ELRError.Create(LRERR_INVALID_COLCOUNT);
    FColCount := Value;
    Rect := GetClientRect;
    AlignControls(nil, Rect);
    Invalidate;
  end;
end;

// TLRGridPanel.SetRowCount
procedure TLRGridPanel.SetRowCount(Value: integer);
var
  Rect: TRect;
begin
  if Value <> FRowCount then
  begin
    if (Value < 1) or ((Height div Value) < MIN_PANEL_SIZE) then
      raise ELRError.Create(LRERR_INVALID_ROWCOUNT);
    FRowCount := Value;
    Rect := GetClientRect;
    AlignControls(nil, Rect);
    Invalidate;
  end;
end;

// TLRGridPanel.SetReplacePanel
procedure TLRGridPanel.SetReplacePanel(Value: TLRChildPanel);
begin
  FReplacePanel := Value;
end;

// TLRGridPanel.SetAfterPrintPanel
procedure TLRGridPanel.SetAfterPrintPanel(const Value: TNotifyEvent);
begin
  FChildPanel.AfterPrint := Value;
end;

// TLRGridPanel.GetAfterPrintPanel
function TLRGridPanel.GetAfterPrintPanel: TNotifyEvent;
begin
  Result := FChildPanel.AfterPrint;
end;

// TLRGridPanel.SetBeforePrintPanel
procedure TLRGridPanel.SetBeforePrintPanel(const Value: TBeforePrintEvent);
begin
  FChildPanel.BeforePrint := Value;
end;

// TLRGridPanel.GetBeforePrintPanel
function TLRGridPanel.GetBeforePrintPanel: TBeforePrintEvent;
begin
  Result := FChildPanel.BeforePrint;
end;

// TLRGridPanel.AddSubPanel
procedure TLRGridPanel.AddSubPanel(Value: TLRChildPanel);
begin
  if FSubPanels.IndexOf(Value) < 0 then
  begin
    FSubPanels.Add(Value);
    Value.SetBounds(Value.Left, Value.Top, FChildPanel.Width, FChildPanel.Height);
  end;
end;

// TLRGridPanel.RemovePanel
procedure TLRGridPanel.RemoveSubPanel(Value: TLRChildPanel);
var
  TmpIndex: integer;
begin
  TmpIndex := FSubPanels.IndexOf(Value);
  if TmpIndex >= 0 then
    FSubPanels.Delete(TmpIndex);
end;

// TLRGridPanel.ResizeSubPanels
procedure TLRGridPanel.ResizeSubPanels(Width, Height: integer);
var
  Control: TWinControl;
  i: integer;
begin
  // 関連しているサブパネルの大きさを変更する
  for i := 0 to FSubPanels.Count - 1 do
  begin
    Control := TWinControl(FSubPanels[i]);
    if Control <> nil then
      if (Control.Width <> FChildPanel.Width) or
        (Control.Height <> FChildPanel.Height) then
        Control.SetBounds(Control.Left, Control.Top, FChildPanel.Width, FChildPanel.Height);
  end;
end;

procedure TLRGridPanel.Resize;
begin
  inherited;
  ResizeSubPanels(FChildPanel.Width, FChildPanel.Height);
end;

// TLRGridPanel.Paint
procedure TLRGridPanel.Paint;
var
  TmpRect: TRect;
  TmpWidth, TmpHeight: integer;
  i: integer;
begin
  with Canvas do
  begin
    if (FColCount > 1) or (FRowCount > 1) then
    begin
      Brush.Color := PROTECT_AREA_COLOR;
      FillRect(GetClientRect);
    end;
    TmpWidth := Trunc(Width / FColCount);
    TmpHeight := Trunc(Height / FRowCount);
    // キャンバスの色を設定
    Brush.Color := clWhite;
    FillRect(Rect(0,0,TmpWidth,TmpHeight));
    // グリッドを描写する
    TmpRect := GetLRRect;
    PaintGrid(Canvas, Width, Height, TmpRect.Left, TmpRect.Top);
    // 輪郭を描写する
    Pen.Color := clBlue;
    Pen.Style := psDot;
    // 横線
    for i := 0 to FRowCount do
    begin
      TmpHeight := Trunc(Height*i/FRowCount);
      if TmpHeight = Height then
        dec(TmpHeight);
      MoveTo(0,TmpHeight);
      LineTo(Width,TmpHeight);
    end;
    // 縦線
    for i := 0 to FColCount do
    begin
      TmpWidth := Trunc(Width*i/FColCount);
      if TmpWidth = Width then
        dec(TmpWidth);
      MoveTo(TmpWidth,0);
      LineTo(TmpWidth,Height);
    end;
    // サブパネルを再描写
    FChildPanel.Repaint;
  end;
end;

// TLRGridPanel.Print
procedure TLRGridPanel.Print(ACanvas: TCanvas; ARect: TRect; PrintScale: double);
var
  Status: TPrintStatus;
  i, j: integer;
  procedure PrintSubPanel(ARow, ACol: integer);
  var
    tmpRect: TRect;
    OffsetY, OffsetX: integer;
    SubPanelX: TLRChildPanel;
  begin
    tmpRect := ARect;
    OffsetY := Trunc(Height* ARow / FRowCount);
    OffsetX := Trunc(Width* ACol / FColCount);
    tmpRect.Right := tmpRect.Left + FChildPanel.Width;
    tmpRect.Bottom := tmpRect.Top + FChildPanel.Height;
    OffsetRect(tmpRect, OffsetX, OffsetY);
    Status := psNormal;
    if Assigned(FOnPrintPanel) then
      FOnPrintPanel(Self, ACol, ARow, tmpRect, Status);
    // ステイタスがpsEndNowの時は印刷中止
    if Status = psEndNow then Exit;
    // ReplacePanelがnilで無い場合はパネルを入れ替える
    if FReplacePanel <> nil then
      SubPanelX := FReplacePanel
    else
      SubPanelX := FChildPanel;
    if Assigned(SubPanelX.BeforePrint) then
      SubPanelX.BeforePrint(SubPanelX, tmpRect, Status);
    if Status = psEndNow then Exit;
    SubPanelX.PrintItem(ACanvas, tmpRect, PrintScale, Status);
    if Assigned(SubPanelX.AfterPrint) then
      SubPanelX.AfterPrint(SubPanelX);
  end;
begin
  // イベントの発生
  Status := psNormal;
  if Assigned(FBeforePrint) then
    FBeforePrint(Self, ARect, Status);
  // ステイタスがpsEndNowの時は印刷中止
  if Status = psEndNow then Exit;
  // FSubPanelをCol,Rowの数分だけ印刷する
  if FPrintDirection = pdVert then
    for i := 0 to FColCount - 1 do
      for j := 0 to FRowCount - 1 do
        PrintSubPanel(j, i)
  else
    for j := 0 to FRowCount - 1 do
      for i := 0 to FColCount - 1 do
        PrintSubPanel(j, i);

  if Assigned(FAfterPrint) then
    FAfterPrint(Self);
end;

// TLRGridPanel.SetParent
procedure TLRGridPanel.SetParent(AParent: TWinControl);
begin
  if (AParent <> nil) and
   (not (AParent is TLightRep) and not (AParent is TLRLayoutPanel)) then
    raise ELRError.Create(LRERR_INVALID_PARENT2);
  inherited SetParent(AParent);
end;

{ TLRSubPanel }

// TLRSubPanel.Create
constructor TLRSubPanel.Create;
begin
  inherited;
  FGridPanel := nil;
  Align := alNone;
  Visible := false;
end;

// TLRSubPanel.SetGridPanel
procedure TLRSubPanel.SetGridPanel(Value: TLRGridPanel);
begin
  if FGridPanel = Value then
    Exit;
  if FGridPanel <> nil then
    FGridPanel.RemoveSubPanel(Self);
  if Value <> nil then
    Value.AddSubPanel(Self);
  FGridPanel := Value;
end;

// TLRSubPanel.SetParent
procedure TLRSubPanel.SetParent(AParent: TWinControl);
begin
  if (AParent <> nil) and
   ((AParent is TLightRep) or (AParent is TCustomLRPanel)) then
    raise ELRError.Create(LRERR_INVALID_PARENT4);
  inherited SetParent(AParent);
end;

// TLRSubPanel.Resize
procedure TLRSubPanel.Resize;
begin
  if FGridPanel = nil then
    inherited;
end;

// TLRSubPanel.Destroy
destructor TLRSubPanel.Destroy;
begin
  if FGridPanel <> nil then
    FGridPanel.RemoveSubPanel(Self);
  inherited;
end;

{ TCustomLRItem }

// TCustomLRItem.Print
procedure TCustomLRItem.Print(ACanvas: TCanvas; ARect: TRect;
      APrintScale: double; APrintStatus: TPrintStatus);
begin
end;

// TCustomLRItem.Create
constructor TCustomLRItem.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csOpaque, csReplicatable];
  Width := 65;
  Height := 17;
  ControlStyle := ControlStyle - [csOpaque];
end;

// TCustomLRItem.SetParent
procedure TCustomLRItem.SetParent(AParent: TWinControl);
begin
  if (AParent <> nil) and not (AParent is TCustomLRPanel) then
    raise ELRError.Create(LRERR_INVALID_PARENT3);
  // LRGridPanel上に作成した場合は、SubPanel上に再配置
  if (AParent is TLRGridPanel) then
    AParent := TLRGridPanel(AParent).FChildPanel;
  inherited SetParent(AParent);
end;

// TCustomLRItem.SetFocusControl
procedure TCustomLRItem.SetFocusControl(Value: TWinControl);
begin
  FFocusControl := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

// TCustomLRItem.Notification
procedure TCustomLRItem.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FFocusControl) then
    FFocusControl := nil;
end;

{ TLRItem }

// TLRItem.Create
constructor TLRItem.Create(AOwner: TComponent);
begin
  inherited;
  FHMargin := 2;
  FVMargin := 2;
  FLineColor := clBlack;
//  Font.OnChange := StyleChanged;
  FTransparent := true;
  Color := clWhite;
end;

// TLRItem.CMTextChanged
procedure TLRItem.CMTextChanged(var Message: TMessage);
begin
  Invalidate;
end;

// TLRItem.SetAlignment
procedure TLRItem.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    Invalidate;
  end;
end;

// TLRItem.SetTransparent
procedure TLRItem.SetTransparent(Value: boolean);
begin
  if FTransParent <> Value then
  begin
    FTransParent := Value;
    Invalidate;
  end;
end;

// TLRItem.SetLayout
procedure TLRItem.SetLayout(Value: TTextLayout);
begin
  if FLayout <> Value then
  begin
    FLayout := Value;
    Invalidate;
  end;
end;

// TLRItem.SetHMargin
procedure TLRItem.SetHMargin(Value: integer);
begin
  if (FHMargin <> Value) and (Value < 256) and (Value > -256) then
  begin
    FHMargin := Value;
    Invalidate;
  end;
end;

// TLRItem.SetVMargin
procedure TLRItem.SetVMargin(Value: integer);
begin
  if (FVMargin <> Value) and (Value < 256) and (Value > -256) then
  begin
    FVMargin := Value;
    Invalidate;
  end;
end;

// TLRItem.SetLineTop
procedure TLRItem.SetLineTop(Value: TLineStyle);
begin
  if FShapeTop <> Value then
  begin
    FShapeTop := Value;
    Invalidate;
  end;
end;

// TLRItem.SetLineLeft
procedure TLRItem.SetLineLeft(Value: TLineStyle);
begin
  if FShapeLeft <> Value then
  begin
    FShapeLeft := Value;
    Invalidate;
  end;
end;

// TLRItem.SetLineRight
procedure TLRItem.SetLineRight(Value: TLineStyle);
begin
  if FShapeRight <> Value then
  begin
    FShapeRight := Value;
    Invalidate;
  end;
end;

// TLRItem.SetLineBottom
procedure TLRItem.SetLineBottom(Value: TLineStyle);
begin
  if FShapeBottom <> Value then
  begin
    FShapeBottom := Value;
    Invalidate;
  end;
end;

// TLRItem.SetLineStyle
procedure TLRItem.SetLineStyle(Canvas: TCanvas; Style: TLineStyle;
  PrintScale: double);
begin
  // Style に応じて、画面上の線の太さを変える
  if (csDesigning in ComponentState) then
    case Style of
      lsHalf: Canvas.Pen.Color := clSilver;
      lsSingle: Canvas.Pen.Color := clGray;
      lsDouble: Canvas.Pen.Color := clBlack;
    end
  else
    case Style of
      lsHalf: Canvas.Pen.Width := Trunc(PrintScale / 2);
      lsSingle: Canvas.Pen.Width := Trunc(PrintScale * 1.2);
      lsDouble: Canvas.Pen.Width := Trunc(PrintScale * 2);
    end;
end;

// TLRItem.SetEditMask
procedure TLRItem.SetEditMask(Value: String);
begin
  if FEditMask <> Value then
  begin
    FEditMask := Value;
    Invalidate;
  end;
end;

// TLRItem.SetWordWrap
procedure TLRItem.SetWordWrap(Value: Boolean);
begin
  if FWordWrap <> Value then
  begin
    FWordWrap := Value;
    Invalidate;
  end;
end;

// TLRItem.SetText
procedure TLRItem.SetText(Value: string);
begin
  if Caption <> Value then
    Caption := Value;
end;

// TLRItem.GetDiaplayText
function TLRItem.GetDiaplayText: string;
var
  s: string;
  i: integer;
  flg: boolean;
begin
  // マスクが指定されていたら
  if (FEditMask <> '') and (Caption <> '') then
  begin
    s := Caption;
    flg := true;
    for i := 1 to Length(s) do
      if not CharInSet(s[i], ['0'..'9', '.', '-', '+']) then
        flg := false;
    // 数字に変換できる場合はFormatFloatを使う
    if flg then
      Result := FormatFloat(FEditMask, StrToFloat(Caption))
    else
      // 数字以外の場合はそのまま
      // Result := Caption;
      // 数字以外の場合はFormatMuskTextを使う
      Result := FormatMaskText(FEditMask, Caption);
  end
  else
    Result := Caption;
end;

// TLRItem.GetText
function TLRItem.GetText: string;
begin
  Result := Caption;
end;

// TLRItem.Paint
procedure TLRItem.Paint;
var
  TmpPrintScale: double;
begin
  TmpPrintScale := 1;
  Print(Canvas, GetClientRect, TmpPrintScale, psNormal);
end;

// TLRItem.Print コントロールの印刷を行う
procedure TLRItem.Print(ACanvas: TCanvas; ARect: TRect;
      APrintScale: double; APrintStatus: TPrintStatus);
var
  SV_TextHeight: integer;
  Text: string;
  Flags: integer;
  CalcRect: TRect;        // Wordwrap時に印刷するテキストの高さを計算するためのRect
  TmpRect: TRect;         // 文字列を描画する領域
  PrintRect: TRect;       // 印刷する領域
  LineOffset: TPoint;
begin
  with ACanvas do
  begin
    Brush.Color := Color;

    if FTransParent then
      Brush.Style := bsClear;

    Font := Self.Font;
    Text := GetDiaplayText;
    SV_TextHeight := TextHeight('|');

    // TmpRectを印刷面のスケールに変換する
    with ARect do
      PrintRect := PrintScaleRect(Rect(Left, Top, Right-1, Bottom-1), APrintScale);

    // bsClearでなければ画面を塗りつぶす(2001/4/1修正)
    //  PDFWriterを使用したときにうまく印刷されない不具合の修正
    if  Brush.Style <> bsClear  then
      FillRect(PrintRect);

    if APrintStatus = psNormal then
    begin
      // フラグのセット
      Flags := DT_NOPREFIX;
      if FWordWrap then
        Flags := Flags or DT_WORDBREAK
      else
        Flags := Flags or DT_SINGLELINE;
      case FAlignment of
        taLeftJustify: Flags := Flags or DT_LEFT;
        taRightJustify: Flags := Flags or DT_RIGHT;
        else
          Flags := Flags or DT_CENTER;
      end;

      // 位置の計算
      TmpRect := PrintRect;
      with CalcRect do
      begin
        Top := 0;
        Bottom := SV_TextHeight;
        Left := 0;
        Right := TmpRect.Right - TmpRect.Left - ToPrintScale(HMargin, APrintScale);
      end;
      DrawText(ACanvas.Handle, PChar(Text), -1, CalcRect, Flags or DT_CALCRECT);
      SV_TextHeight := CalcRect.Bottom;

      // 横位置調整
      with TmpRect do
      case FAlignment of
        taLeftJustify: Left := Left + ToPrintScale(HMargin, APrintScale);
        taRightJustify: Right := Right - ToPrintScale(HMargin, APrintScale);
      end;
      // 縦位置調整
      with TmpRect do
      case FLayout of
        tlTop: Top := Top + ToPrintScale(VMargin, APrintScale);
        tlBottom: Top := Bottom - ToPrintScale(VMargin, APrintScale) - SV_TEXTHEIGHT;
        else
          Top := Top + (PrintRect.Bottom - PrintRect.Top - SV_TEXTHEIGHT) div 2;
      end;

      // 文字列の描写
      DrawText(Handle, PChar(Text), -1, TmpRect, Flags);
    end;
    if (APrintStatus = psNormal) or (APrintStatus = psLineOnly) then
    begin
      // 枠線オフセットの計算
      if (csDesigning in ComponentState) then
      begin
        LineOffset.X := 0;
        LineOffset.Y := 0;
      end
      else
      begin
        LineOffset.X := trunc(APrintScale);
        LineOffset.Y := trunc(APrintScale);
      end;

      // 枠線の描写
      Pen.Color := FLineColor;
      if LineTop <> lsNone then
      begin
        SetLineStyle(ACanvas, LineTop, APrintScale);
        MoveTo(PrintRect.Left-LineOffset.x, PrintRect.Top-LineOffset.x);
        LineTo(PrintRect.Right, PrintRect.Top-LineOffset.y);
      end;
      if LineLeft <> lsNone then
      begin
        SetLineStyle(ACanvas, LineLeft, APrintScale);
        MoveTo(PrintRect.Left-LineOffset.x, PrintRect.Top-LineOffset.y);
        LineTo(PrintRect.Left-LineOffset.x, PrintRect.Bottom);
      end;
      if LineRight <> lsNone then
      begin
        SetLineStyle(ACanvas, LineRight, APrintScale);
        MoveTo(PrintRect.Right, PrintRect.Top-LineOffset.y);
        LineTo(PrintRect.Right, PrintRect.Bottom);
      end;
      if LineBottom <> lsNone then
      begin
        SetLineStyle(ACanvas, LineBottom, APrintScale);
        MoveTo(PrintRect.Left-LineOffset.x, PrintRect.Bottom);
        LineTo(PrintRect.Right, PrintRect.Bottom);
      end;
    end;
  end;
  if  csDesigning in ComponentState  then       // 設計時枠線を書く
    DrowDesignFrame(ACanvas, Color, ARect,
      LineLeft, LineTop, LineRight, LineBottom);
end;

end.
